      *=====================================================================*                 RADDAT
      *  WSDL2RPG: MultiRef                                                 *                 RADDAT
      *=====================================================================*                 RADDAT
      *  Author  :  Thomas Raddatz                                          *                 RADDAT
      *  Date    :  06.11.2007                                              *                 RADDAT
      *  E-mail  :  thomas.raddatz@Tools400.de                              *                 RADDAT
      *  Homepage:  www.tools400.de                                         *                 RADDAT
      *=====================================================================*                 RADDAT
      *                                                                     *                 RADDAT
      *  This software is free software, you can redistribute it and/or     *                 RADDAT
      *  modify it under the terms of the GNU General Public License (GPL)  *                 RADDAT
      *  as published by the Free Software Foundation.                      *                 RADDAT
      *                                                                     *                 RADDAT
      *  See GNU General Public License for details.                        *                 RADDAT
      *          http://www.opensource.org                                  *                 RADDAT
      *          http://www.opensource.org/licenses/gpl-license.html        *                 RADDAT
      *                                                                     *                 RADDAT
      *=====================================================================*                 RADDAT
      *  History:                                                           *                 RADDAT
      *                                                                     *                 RADDAT
      *  Datum       Name          nderung                                 *                 RADDAT
      *  ----------  ------------  ---------------------------------------  *                 RADDAT
      *  22.06.2009  Th.Raddatz    Replaced literal '#' with Unicode        *                 RADDAT
      *                            constant 'cNUMBER_SIGN'.                 *                 RADDAT
      *                                                                     *                 RADDAT
      *=====================================================================*                 RADDAT
      *   >>PRE-COMPILER<<                                                  *                 RADDAT
      *                                                                     *                 RADDAT
      *     >>CRTCMD<<  CRTRPGMOD   MODULE(&LI/&OB) +                       *                 RADDAT
      *                             SRCFILE(&SL/&SF) +                      *                 RADDAT
      *                             SRCMBR(&SM);                            *                 RADDAT
      *                                                                     *                 RADDAT
      *     >>COMPILE<<                                                     *                 RADDAT
      *       >>PARM<< TRUNCNBR(*NO);                                       *                 RADDAT
      *       >>PARM<< DBGVIEW(*LIST);                                      *                 RADDAT
      *       >>PARM<< TGTRLS(V5R3M0  );                                    *                 RADDAT
      *     >>END-COMPILE<<                                                 *                 RADDAT
      *                                                                     *                 RADDAT
      *     >>EXECUTE<<                                                     *                 RADDAT
      *                                                                     *                 RADDAT
      *   >>END-PRE-COMPILER<<                                              *                 RADDAT
      *=====================================================================*                 RADDAT
 CPY H NOMAIN                                                                                 RADDAT
      /UNDEFINE NO_DECEDIT                                                                    RADDAT
      *=====================================================================*                 RADDAT
      *                                                                                       RADDAT
      * ------------------------------------                                                  RADDAT
      *  Constants                                                                            RADDAT
      * ------------------------------------                                                  RADDAT
     D cNUMBER_SIGN    C                   const(u'0023')                                     RADDAT
      *                                                                                       RADDAT
      * ------------------------------------                                                  RADDAT
      *  Type Definitions                                                                     RADDAT
      * ------------------------------------                                                  RADDAT
      *                                                                                       RADDAT
      * ------------------------------------                                                  RADDAT
      *  Exported prototypes                                                                  RADDAT
      * ------------------------------------                                                  RADDAT
 CPY  /COPY QWSDL2RPG,PWSDL2R94                    WSDL2RPG: MultiRef                         RADDAT
      *                                                                                       RADDAT
      * ------------------------------------                                                  RADDAT
      *  Imported prototypes                                                                  RADDAT
      * ------------------------------------                                                  RADDAT
 CPY  /COPY QBASICS1,PBASICS1                      Tools/400 Runtime Library
 CPY  /COPY QWSDL2RPG,PWSDL2R97                    WSDL2RPG: eXpat Adapter                    RADDAT
      *                                                                                       RADDAT
      * ------------------------------------                                                  RADDAT
      *  Internal prototypes                                                                  RADDAT
      * ------------------------------------                                                  RADDAT
      *                                                                                       RADDAT
      *   Handles <multiRef> elements.                                                        RADDAT
     D multiRefImplStart...                                                                   RADDAT
     D                 PR                  extproc(g_multiRef.cbStart)                        RADDAT
     D   userdata                      *   value                                              RADDAT
     D   depth                       10I 0 value                                              RADDAT
     D   namespace                 1024A   varying const                                      RADDAT
     D   name                      1024A   varying const                                      RADDAT
     D   path                     24576A   varying const                                      RADDAT
     D   attrs                         *   dim(32767)                                         RADDAT
     D                                     const options(*varsize)                            RADDAT
      *                                                                                       RADDAT
      *   Handles <multiRef> elements.                                                        RADDAT
     D multiRefImplEnd...                                                                     RADDAT
     D                 PR                  extproc(g_multiRef.cbEnd)                          RADDAT
     D   userdata                      *   value                                              RADDAT
     D   depth                       10I 0 value                                              RADDAT
     D   namespace                 1024A   varying const                                      RADDAT
     D   name                      1024A   varying const                                      RADDAT
     D   path                     24576A   varying const                                      RADDAT
     D   value                    65535A   varying const                                      RADDAT
     D   attrs                         *   dim(32767)                                         RADDAT
     D                                     const options(*varsize)                            RADDAT
      *                                                                                       RADDAT
      * ------------------------------------                                                  RADDAT
      *  Global fields & constants                                                            RADDAT
      * ------------------------------------                                                  RADDAT
     D cATTR_HREF      C                   'href'                                             RADDAT
      *                                                                                       RADDAT
     D g_hMultiRef     S                   like(BasicMap_handle_t) inz                        RADDAT
      *                                                                                       RADDAT
     D g_multiRef      DS                  likeds(wsdl_multiRef_t) inz                        RADDAT
      *                                                                                       RADDAT
      *=====================================================================*                 RADDAT
      *  Creates a <multiRef> map.                                                            RADDAT
      *=====================================================================*                 RADDAT
     P MultiRef_new...                                                                        RADDAT
     P                 B                   export                                             RADDAT
      *                                                                                       RADDAT
     D MultiRef_new...                                                                        RADDAT
     D                 PI                                                                     RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /free
                                                                                            //RADDAT
         p_assert(BasicMap_isNull(g_hMultiRef)
                  : 'Map handle must be NULL');                                             //RADDAT
                                                                                            //RADDAT
         g_hMultiRef = BasicMap_new();                                                      //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /end-free
      *                                                                                       RADDAT
     P MultiRef_new...                                                                        RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
      *=====================================================================*                 RADDAT
      *  Returns the procedure pointer of the <multiRef>                                      RADDAT
      *  start callback procedure.                                                            RADDAT
      *=====================================================================*                 RADDAT
     P MultiRef_getStartCallback...                                                           RADDAT
     P                 B                   export                                             RADDAT
      *                                                                                       RADDAT
     D MultiRef_getStartCallback...                                                           RADDAT
     D                 PI              *   procptr                                            RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /free
                                                                                            //RADDAT
         return %paddr('WSDL2R94_MultiRef_startCallback');                                  //RADDAT
                                                                                            //RADDAT
      /end-free
      *                                                                                       RADDAT
     P MultiRef_getStartCallback...                                                           RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
      *=====================================================================*                 RADDAT
      *  Returns the procedure pointer of the <multiRef>                                      RADDAT
      *  end callback procedure.                                                              RADDAT
      *=====================================================================*                 RADDAT
     P MultiRef_getEndCallback...                                                             RADDAT
     P                 B                   export                                             RADDAT
      *                                                                                       RADDAT
     D MultiRef_getEndCallback...                                                             RADDAT
     D                 PI              *   procptr                                            RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /free
                                                                                            //RADDAT
         return %paddr('WSDL2R94_MultiRef_endCallback');                                    //RADDAT
                                                                                            //RADDAT
      /end-free
      *                                                                                       RADDAT
     P MultiRef_getEndCallback...                                                             RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
      *=====================================================================*                 RADDAT
      *  Returns cTrue if the given element references a <multiRef> element.                  RADDAT
      *=====================================================================*                 RADDAT
     P MultiRef_isReference...                                                                RADDAT
     P                 B                   export                                             RADDAT
      *                                                                                       RADDAT
     D MultiRef_isReference...                                                                RADDAT
     D                 PI              N                                                      RADDAT
     D  i_attrs                        *   const  dim(32767) options(*varsize)                RADDAT
      *                                                                                       RADDAT
      *  Helper fields                                                                        RADDAT
     D hRef            S                   like(wsdl_name_t      ) inz                        RADDAT
     D grave           S              1A   inz                                                RADDAT
     D graveU          S              2C   inz                                                RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /free
                                                                                            //RADDAT
         hRef = XMLSAXParser_getAttributeValueByQName(i_attrs: cATTR_HREF);                 //RADDAT
 B01     if (%len(hRef) > 1 and %ucs2(%subst(hRef: 1: 1)) = cNUMBER_SIGN);                  //RADDAT
            return cTrue;                                                                   //RADDAT
 X01     else;                                                                              //RADDAT
            return cFalse;                                                                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
      /end-free
      *                                                                                       RADDAT
     P MultiRef_isReference...                                                                RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
      *=====================================================================*                 RADDAT
      *  Returns cTrue if the given element is a <multiRef> data element.                     RADDAT
      *=====================================================================*                 RADDAT
     P MultiRef_isData...                                                                     RADDAT
     P                 B                   export                                             RADDAT
      *                                                                                       RADDAT
     D MultiRef_isData...                                                                     RADDAT
     D                 PI              N                                                      RADDAT
     D  i_attrs                        *   const  dim(32767) options(*varsize)                RADDAT
      *                                                                                       RADDAT
      *  Helper fields                                                                        RADDAT
     D hRef            S                   like(wsdl_name_t      ) inz                        RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /free
                                                                                            //RADDAT
         hRef = XMLSAXParser_getAttributeValueByQName(i_attrs: cATTR_ID);                   //RADDAT
 B01     if (hRef <> '');                                                                   //RADDAT
            return cTrue;                                                                   //RADDAT
 X01     else;                                                                              //RADDAT
            return cFalse;                                                                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
      /end-free
      *                                                                                       RADDAT
     P MultiRef_isData...                                                                     RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
      *=====================================================================*                 RADDAT
      *  Adds an entry to the <multiRef> map.                                                 RADDAT
      *=====================================================================*                 RADDAT
     P MultiRef_put...                                                                        RADDAT
     P                 B                   export                                             RADDAT
      *                                                                                       RADDAT
     D MultiRef_put...                                                                        RADDAT
     D                 PI                                                                     RADDAT
     D  i_attrs                        *   const  dim(32767) options(*varsize)                RADDAT
     D  i_userData                     *   const                                              RADDAT
     D  i_depth                      10I 0 const                                              RADDAT
     D  i_namespace                1024A   const  varying                                     RADDAT
     D  i_name                     1024A   const  varying                                     RADDAT
     D  i_path                    24576A   const  varying                                     RADDAT
     D  i_cbStart                      *   const  procptr                                     RADDAT
     D  i_cbEnd                        *   const  procptr                                     RADDAT
      *                                                                                       RADDAT
      *  Local fields                                                                         RADDAT
     D hRef            S                   like(wsdl_name_t      ) inz                        RADDAT
     D multiRef        DS                  likeds(wsdl_multiRef_t ) inz                       RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /free
                                                                                            //RADDAT
         hRef = XMLSAXParser_getAttributeValueByQName(i_attrs: cATTR_HREF);                 //RADDAT
 B01     if (%len(hRef) > 1 and %ucs2(%subst(hRef: 1: 1)) = cNUMBER_SIGN);                  //RADDAT
            hRef = %subst(hRef: 2);                                                         //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         multiRef.isActive  = cFalse;                                                       //RADDAT
         multiRef.userData  = i_userData;                                                   //RADDAT
         multiRef.cbStart   = i_cbStart;                                                    //RADDAT
         multiRef.cbEnd     = i_cbEnd;                                                      //RADDAT
         multiRef.depth     = i_depth;                                                      //RADDAT
         multiRef.name      = i_name;                                                       //RADDAT
         multiRef.namespace = i_namespace;                                                  //RADDAT
         multiRef.pathLen   = 0;                                                            //RADDAT
                                                                                            //RADDAT
         BasicMap_put(g_hMultiRef
                      : hRef
                      : %addr(multiRef)
                      : %size(multiRef));                                                   //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /end-free
      *                                                                                       RADDAT
     P MultiRef_put...                                                                        RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
      *=====================================================================*                 RADDAT
      *  Returns the <multiRef> information that is associated to a                           RADDAT
      *  given key.                                                                           RADDAT
      *=====================================================================*                 RADDAT
     P MultiRef_get...                                                                        RADDAT
     P                 B                   export                                             RADDAT
      *                                                                                       RADDAT
     D MultiRef_get...                                                                        RADDAT
     D                 PI                         likeds(wsdl_multiRef_t)                     RADDAT
     D  i_attrs                        *   const  dim(32767) options(*varsize)                RADDAT
     D  i_depth                      10I 0 const                                              RADDAT
     D  i_name                     1024A   const  varying                                     RADDAT
      *                                                                                       RADDAT
      *  Return value                                                                         RADDAT
     D multiRef        DS                  likeds(wsdl_multiRef_t ) inz                       RADDAT
      *                                                                                       RADDAT
      *  Local fields                                                                         RADDAT
     D hRef            S                   like(wsdl_name_t      ) inz                        RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /free
                                                                                            //RADDAT
         hRef = XMLSAXParser_getAttributeValueByQName(i_attrs: cATTR_ID);                   //RADDAT
                                                                                            //RADDAT
         BasicMap_get(g_hMultiRef
                      : hRef
                      : %addr(multiRef)
                      : %size(multiRef));                                                   //RADDAT
                                                                                            //RADDAT
         multiRef.pathLen  = %len(i_name);                                                  //RADDAT
         multiRef.isActive = cTrue;                                                         //RADDAT
                                                                                            //RADDAT
         return multiRef;                                                                   //RADDAT
                                                                                            //RADDAT
      /end-free
      *                                                                                       RADDAT
     P MultiRef_get...                                                                        RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
      *=====================================================================*                 RADDAT
      *  Releases an active <multiRef> environment.                                           RADDAT
      *=====================================================================*                 RADDAT
     P MultiRef_release...                                                                    RADDAT
     P                 B                   export                                             RADDAT
      *                                                                                       RADDAT
     D MultiRef_release...                                                                    RADDAT
     D                 PI                                                                     RADDAT
     D  io_multiRef                               likeds(wsdl_multiRef_t)                     RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /free
                                                                                            //RADDAT
         clear io_multiRef;                                                                 //RADDAT
         io_multiRef.isActive = cFalse;                                                     //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /end-free
      *                                                                                       RADDAT
     P MultiRef_release...                                                                    RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
      *=====================================================================*                 RADDAT
      *  Deletes a given <multiRef> map.                                                      RADDAT
      *=====================================================================*                 RADDAT
     P MultiRef_delete...                                                                     RADDAT
     P                 B                   export                                             RADDAT
      *                                                                                       RADDAT
     D MultiRef_delete...                                                                     RADDAT
     D                 PI                                                                     RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /free
                                                                                            //RADDAT
         BasicMap_delete(g_hMultiRef);                                                      //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /end-free
      *                                                                                       RADDAT
     P MultiRef_delete...                                                                     RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
      *=====================================================================*                 RADDAT
      *  Returns a NULL <multiRef> map.                                                       RADDAT
      *=====================================================================*                 RADDAT
     P MultiRef_null...                                                                       RADDAT
     P                 B                   export                                             RADDAT
      *                                                                                       RADDAT
     D MultiRef_null...                                                                       RADDAT
     D                 PI                         like(BasicMap_handle_t )                    RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /free
                                                                                            //RADDAT
         return BasicMap_null();                                                            //RADDAT
                                                                                            //RADDAT
      /end-free
      *                                                                                       RADDAT
     P MultiRef_null...                                                                       RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
      *=====================================================================*                 RADDAT
      *  Returns cTrue if a given <multiRef> map is NULL.                                     RADDAT
      *=====================================================================*                 RADDAT
     P MultiRef_isNull...                                                                     RADDAT
     P                 B                   export                                             RADDAT
      *                                                                                       RADDAT
     D MultiRef_isNull...                                                                     RADDAT
     D                 PI              N                                                      RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /free
                                                                                            //RADDAT
         return BasicMap_isNull(g_hMultiRef);                                               //RADDAT
                                                                                            //RADDAT
      /end-free
      *                                                                                       RADDAT
     P MultiRef_isNull...                                                                     RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
      * =====================================================================                 RADDAT
      *   Handles <multiRef> elements.                                                        RADDAT
      * =====================================================================                 RADDAT
     P MultiRef_startCallback...                                                              RADDAT
     P                 B                   export                                             RADDAT
      *                                                                                       RADDAT
     D MultiRef_startCallback...                                                              RADDAT
     D                 PI                                                                     RADDAT
     D   userdata                      *   value                                              RADDAT
     D   depth                       10I 0 value                                              RADDAT
     D   namespace                 1024A   varying const                                      RADDAT
     D   name                      1024A   varying const                                      RADDAT
     D   path                     24576A   varying const                                      RADDAT
     D   attrs                         *   dim(32767)                                         RADDAT
     D                                     const options(*varsize)                            RADDAT
      *                                                                                       RADDAT
      *   Helper fields                                                                       RADDAT
     D tmpPath         S                   like(path) inz                                     RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                 RADDAT
      /free
                                                                                            //RADDAT
 B01     if (name = 'multiRef');                                                            //RADDAT
            g_multiRef = MultiRef_get(attrs: depth: name);                                  //RADDAT
                                                                                            //RADDAT
            multiRefImplStart(g_multiRef.userdata
                              : g_multiRef.depth
                              : g_multiRef.namespace
                              : g_multiRef.name
                              : ''
                              : attrs);                                                     //RADDAT
            return;                                                                         //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         tmpPath = %replace(g_multiRef.name: path: 2: g_multiref.pathLen);                  //RADDAT
                                                                                            //RADDAT
         multiRefImplStart(g_multiRef.userdata
                           : depth
                           : namespace
                           : name
                           : tmpPath
                           : attrs);                                                        //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /end-free
      *                                                                                       RADDAT
     P MultiRef_startCallback...                                                              RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
      * =====================================================================                 RADDAT
      *   Returns the Soap Fault Details Information.                                         RADDAT
      * =====================================================================                 RADDAT
     P MultiRef_endCallback...                                                                RADDAT
     P                 B                   export                                             RADDAT
      *                                                                                       RADDAT
     D MultiRef_endCallback...                                                                RADDAT
     D                 PI                                                                     RADDAT
     D   userdata                      *   value                                              RADDAT
     D   depth                       10I 0 value                                              RADDAT
     D   namespace                 1024A   varying const                                      RADDAT
     D   name                      1024A   varying const                                      RADDAT
     D   path                     24576A   varying const                                      RADDAT
     D   value                    65535A   varying const                                      RADDAT
     D   attrs                         *   dim(32767)                                         RADDAT
     D                                     const options(*varsize)                            RADDAT
      *                                                                                       RADDAT
      *   Helper fields                                                                       RADDAT
     D tmpPath         S                   like(path) inz                                     RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                 RADDAT
      /free
                                                                                            //RADDAT
 B01     if (name = 'multiRef');                                                            //RADDAT
            multiRefImplEnd(g_multiRef.userdata
                            : g_multiRef.depth
                            : g_multiRef.namespace
                            : g_multiRef.name
                            : ''
                            : value
                            : attrs);                                                       //RADDAT
            MultiRef_release(g_multiRef);                                                   //RADDAT
            return;                                                                         //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         tmpPath = %replace(g_multiRef.name: path: 2: g_multiref.pathLen);                  //RADDAT
                                                                                            //RADDAT
         multiRefImplEnd(g_multiRef.userdata
                         : depth
                         : namespace
                         : name
                         : tmpPath
                         : value
                         : attrs);                                                          //RADDAT
      /end-free
      *                                                                                       RADDAT
     P MultiRef_endCallback...                                                                RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
